
# ----------------------------------------------------------------------------
# Clock Source - Bank 13
# ----------------------------------------------------------------------------
set_property -dict {PACKAGE_PIN Y9 IOSTANDARD LVCMOS33} [get_ports clk]

# ----------------------------------------------------------------------------
# User Push Buttons - Bank 34
# ----------------------------------------------------------------------------
set_property -dict {PACKAGE_PIN P16 IOSTANDARD LVCMOS33} [get_ports reset]

# ----------------------------------------------------------------------------
# User DIP Switches - Bank 35
# ---------------------------------------------------------------------------- 
set_property -dict {PACKAGE_PIN F22 IOSTANDARD LVCMOS33} [get_ports sw[0]];  # "SW0"
set_property -dict {PACKAGE_PIN G22 IOSTANDARD LVCMOS33} [get_ports sw[1]];  # "SW1"
set_property -dict {PACKAGE_PIN H22 IOSTANDARD LVCMOS33} [get_ports sw[2]];  # "SW2"
set_property -dict {PACKAGE_PIN F21 IOSTANDARD LVCMOS33} [get_ports sw[3]];  # "SW3"
set_property -dict {PACKAGE_PIN H19 IOSTANDARD LVCMOS33} [get_ports sw[4]];  # "SW4"
set_property -dict {PACKAGE_PIN H18 IOSTANDARD LVCMOS33} [get_ports sw[5]];  # "SW5"
set_property -dict {PACKAGE_PIN H17 IOSTANDARD LVCMOS33} [get_ports sw[6]];  # "SW6"
set_property -dict {PACKAGE_PIN M15 IOSTANDARD LVCMOS33} [get_ports sw[7]];  # "SW7"


# ----------------------------------------------------------------------------
# JA Pmod - Bank 13
# ----------------------------------------------------------------------------
set_property -dict {PACKAGE_PIN Y11 IOSTANDARD LVCMOS33} [get_ports reset_out_Left]
set_property -dict {PACKAGE_PIN AA11 IOSTANDARD LVCMOS33} [get_ports href_Left]
set_property -dict {PACKAGE_PIN Y10 IOSTANDARD LVCMOS33} [get_ports siod_Left]  
set_property -dict {PACKAGE_PIN AA9 IOSTANDARD LVCMOS33} [get_ports pwdn_Left] 
set_property -dict {PACKAGE_PIN AB11 IOSTANDARD LVCMOS33} [get_ports xclk_Left]
set_property -dict {PACKAGE_PIN AB10 IOSTANDARD LVCMOS33} [get_ports vsync_Left]
set_property -dict {PACKAGE_PIN AB9 IOSTANDARD LVCMOS33}  [get_ports sioc_Left]
set_property -dict {PACKAGE_PIN AA8 IOSTANDARD LVCMOS33}  [get_ports pclk_Left]  
set_property CLOCK_DEDICATED_ROUTE FALSE [get_nets pclk_Left];

# ----------------------------------------------------------------------------
# JB Pmod - Bank 13
# ----------------------------------------------------------------------------
set_property -dict {PACKAGE_PIN W12 IOSTANDARD LVCMOS33} [get_ports {vdin_Left[0]}]
set_property -dict {PACKAGE_PIN W11 IOSTANDARD LVCMOS33} [get_ports {vdin_Left[2]}]
set_property -dict {PACKAGE_PIN V10 IOSTANDARD LVCMOS33} [get_ports {vdin_Left[4]}]
set_property -dict {PACKAGE_PIN W8 IOSTANDARD LVCMOS33} [get_ports {vdin_Left[6]}]
set_property -dict {PACKAGE_PIN V12 IOSTANDARD LVCMOS33} [get_ports {vdin_Left[1]}]
set_property -dict {PACKAGE_PIN W10 IOSTANDARD LVCMOS33} [get_ports {vdin_Left[3]}]
set_property -dict {PACKAGE_PIN V9 IOSTANDARD LVCMOS33} [get_ports {vdin_Left[5]}]
set_property -dict {PACKAGE_PIN V8 IOSTANDARD LVCMOS33} [get_ports {vdin_Left[7]}]

#Type 1
## ----------------------------------------------------------------------------
## JC Pmod - Bank 13
## ---------------------------------------------------------------------------- 
set_property -dict {PACKAGE_PIN AB6 IOSTANDARD LVCMOS33} [get_ports href_Right];  # 1
set_property -dict {PACKAGE_PIN AB7 IOSTANDARD LVCMOS33} [get_ports reset_out_Right];  # 0
set_property -dict {PACKAGE_PIN AA4 IOSTANDARD LVCMOS33} [get_ports pwdn_Right];  # 3
set_property -dict {PACKAGE_PIN Y4  IOSTANDARD LVCMOS33} [get_ports siod_Right];  # 2
set_property -dict {PACKAGE_PIN T6  IOSTANDARD LVCMOS33} [get_ports vsync_Right];  # 5
set_property -dict {PACKAGE_PIN R6  IOSTANDARD LVCMOS33} [get_ports xclk_Right];  # 4
set_property -dict {PACKAGE_PIN U4  IOSTANDARD LVCMOS33} [get_ports pclk_Right];  # 7
set_property -dict {PACKAGE_PIN T4  IOSTANDARD LVCMOS33} [get_ports sioc_Right];  # 6
set_property CLOCK_DEDICATED_ROUTE FALSE [get_nets pclk_Right];

## ----------------------------------------------------------------------------
## JD Pmod - Bank 13
## ---------------------------------------------------------------------------- 
set_property -dict {PACKAGE_PIN W7 IOSTANDARD LVCMOS33} [get_ports {vdin_Right[1]}];  # 1
set_property -dict {PACKAGE_PIN V7 IOSTANDARD LVCMOS33} [get_ports {vdin_Right[0]}];  # 0
set_property -dict {PACKAGE_PIN V4 IOSTANDARD LVCMOS33} [get_ports {vdin_Right[3]}];  # 3
set_property -dict {PACKAGE_PIN V5 IOSTANDARD LVCMOS33} [get_ports {vdin_Right[2]}];  # 2
set_property -dict {PACKAGE_PIN W5 IOSTANDARD LVCMOS33} [get_ports {vdin_Right[5]}];  # 5
set_property -dict {PACKAGE_PIN W6 IOSTANDARD LVCMOS33} [get_ports {vdin_Right[4]}];  # 4
set_property -dict {PACKAGE_PIN U5 IOSTANDARD LVCMOS33} [get_ports {vdin_Right[7]}];  # 7
set_property -dict {PACKAGE_PIN U6 IOSTANDARD LVCMOS33} [get_ports {vdin_Right[6]}];  # 6

# ----------------------------------------------------------------------------
# JC Pmod - Bank 13
# ---------------------------------------------------------------------------- 
#set_property -dict {PACKAGE_PIN AB6 IOSTANDARD LVCMOS33} [get_ports pmod_out[9]];  # 1
#set_property -dict {PACKAGE_PIN AB7 IOSTANDARD LVCMOS33} [get_ports pmod_out[8]];  # 0
#set_property -dict {PACKAGE_PIN AA4 IOSTANDARD LVCMOS33} [get_ports pmod_out[11]];  # 3
#set_property -dict {PACKAGE_PIN Y4  IOSTANDARD LVCMOS33} [get_ports pmod_out[10]];  # 2
#set_property -dict {PACKAGE_PIN T6  IOSTANDARD LVCMOS33} [get_ports pmod_out[13]];  # 5
#set_property -dict {PACKAGE_PIN R6  IOSTANDARD LVCMOS33} [get_ports pmod_out[12]];  # 4
#set_property -dict {PACKAGE_PIN U4  IOSTANDARD LVCMOS33} [get_ports pmod_out[15]];  # 7
#set_property -dict {PACKAGE_PIN T4  IOSTANDARD LVCMOS33} [get_ports pmod_out[14]];  # 6

# ----------------------------------------------------------------------------
# JD Pmod - Bank 13
# ---------------------------------------------------------------------------- 
#set_property -dict {PACKAGE_PIN W7 IOSTANDARD LVCMOS33} [get_ports {pmod_out[1]}];  # 1
#set_property -dict {PACKAGE_PIN V7 IOSTANDARD LVCMOS33} [get_ports {pmod_out[0]}];  # 0
#set_property -dict {PACKAGE_PIN V4 IOSTANDARD LVCMOS33} [get_ports {pmod_out[3]}];  # 3
#set_property -dict {PACKAGE_PIN V5 IOSTANDARD LVCMOS33} [get_ports {pmod_out[2]}];  # 2
#set_property -dict {PACKAGE_PIN W5 IOSTANDARD LVCMOS33} [get_ports {pmod_out[5]}];  # 5
#set_property -dict {PACKAGE_PIN W6 IOSTANDARD LVCMOS33} [get_ports {pmod_out[4]}];  # 4
#set_property -dict {PACKAGE_PIN U5 IOSTANDARD LVCMOS33} [get_ports {pmod_out[7]}];  # 7
#set_property -dict {PACKAGE_PIN U6 IOSTANDARD LVCMOS33} [get_ports {pmod_out[6]}];  # 6

# ----------------------------------------------------------------------------
# User LEDs - Bank 33
# ----------------------------------------------------------------------------
set_property -dict { PACKAGE_PIN T22   IOSTANDARD LVCMOS25 } [get_ports { LED[0] }]; #IO_L18P_T2_A24_15 Sch=led[0]
set_property -dict { PACKAGE_PIN T21   IOSTANDARD LVCMOS25 } [get_ports { LED[1] }]; #IO_L24P_T3_RS1_15 Sch=led[1]
set_property -dict { PACKAGE_PIN U22   IOSTANDARD LVCMOS25 } [get_ports { LED[2] }]; #IO_L17N_T2_A25_15 Sch=led[2]
set_property -dict { PACKAGE_PIN U21   IOSTANDARD LVCMOS25 } [get_ports { LED[3] }]; #IO_L8P_T1_D11_14 Sch=led[3]
set_property -dict { PACKAGE_PIN V22   IOSTANDARD LVCMOS25 } [get_ports { LED[4] }]; #IO_L7P_T1_D09_14 Sch=led[4]
set_property -dict { PACKAGE_PIN W22   IOSTANDARD LVCMOS25 } [get_ports { LED[5] }]; #IO_L18N_T2_A11_D27_14 Sch=led[5]
set_property -dict { PACKAGE_PIN U19   IOSTANDARD LVCMOS25 } [get_ports { LED[6] }]; #IO_L17P_T2_A14_D30_14 Sch=led[6]
set_property -dict { PACKAGE_PIN U14   IOSTANDARD LVCMOS25 } [get_ports { LED[7] }]; #IO_L18P_T2_A12_D28_14 Sch=led[7]


#
# ZedBoard HDMI I2C Controller
#

set_property PACKAGE_PIN AA18 [get_ports zed_hdmi_iic_scl_io]
set_property IOSTANDARD LVCMOS25 [get_ports zed_hdmi_iic_scl_io]
set_property SLEW SLOW [get_ports zed_hdmi_iic_scl_io]
set_property DRIVE 8 [get_ports zed_hdmi_iic_scl_io]

set_property PACKAGE_PIN Y16 [get_ports zed_hdmi_iic_sda_io]
set_property IOSTANDARD LVCMOS25 [get_ports zed_hdmi_iic_sda_io]
set_property SLEW SLOW [get_ports zed_hdmi_iic_sda_io]
set_property DRIVE 8 [get_ports zed_hdmi_iic_sda_io]

#
# ZedBoard HDMI Output
#

set_property PACKAGE_PIN W18 [get_ports hdmio_io_clk]
set_property IOSTANDARD LVCMOS25 [get_ports hdmio_io_clk]

set_property PACKAGE_PIN W17 [get_ports hdmio_io_vsync]
set_property IOSTANDARD LVCMOS25 [get_ports hdmio_io_vsync]

set_property PACKAGE_PIN V17 [get_ports hdmio_io_hsync]
set_property IOSTANDARD LVCMOS25 [get_ports hdmio_io_hsync]

set_property PACKAGE_PIN U16 [get_ports hdmio_io_de]
set_property IOSTANDARD LVCMOS25 [get_ports hdmio_io_de]

set_property PACKAGE_PIN Y13 [get_ports {hdmio_io_data[0]}]
set_property IOSTANDARD LVCMOS25 [get_ports {hdmio_io_data[0]}]

set_property PACKAGE_PIN AA13 [get_ports {hdmio_io_data[1]}]
set_property IOSTANDARD LVCMOS25 [get_ports {hdmio_io_data[1]}]

set_property PACKAGE_PIN AA14 [get_ports {hdmio_io_data[2]}]
set_property IOSTANDARD LVCMOS25 [get_ports {hdmio_io_data[2]}]

set_property PACKAGE_PIN Y14 [get_ports {hdmio_io_data[3]}]
set_property IOSTANDARD LVCMOS25 [get_ports {hdmio_io_data[3]}]

set_property PACKAGE_PIN AB15 [get_ports {hdmio_io_data[4]}]
set_property IOSTANDARD LVCMOS25 [get_ports {hdmio_io_data[4]}]

set_property PACKAGE_PIN AB16 [get_ports {hdmio_io_data[5]}]
set_property IOSTANDARD LVCMOS25 [get_ports {hdmio_io_data[5]}]

set_property PACKAGE_PIN AA16 [get_ports {hdmio_io_data[6]}]
set_property IOSTANDARD LVCMOS25 [get_ports {hdmio_io_data[6]}]

set_property PACKAGE_PIN AB17 [get_ports {hdmio_io_data[7]}]
set_property IOSTANDARD LVCMOS25 [get_ports {hdmio_io_data[7]}]

set_property PACKAGE_PIN AA17 [get_ports {hdmio_io_data[8]}]
set_property IOSTANDARD LVCMOS25 [get_ports {hdmio_io_data[8]}]

set_property PACKAGE_PIN Y15 [get_ports {hdmio_io_data[9]}]
set_property IOSTANDARD LVCMOS25 [get_ports {hdmio_io_data[9]}]

set_property PACKAGE_PIN W13 [get_ports {hdmio_io_data[10]}]
set_property IOSTANDARD LVCMOS25 [get_ports {hdmio_io_data[10]}]

set_property PACKAGE_PIN W15 [get_ports {hdmio_io_data[11]}]
set_property IOSTANDARD LVCMOS25 [get_ports {hdmio_io_data[11]}]

set_property PACKAGE_PIN V15 [get_ports {hdmio_io_data[12]}]
set_property IOSTANDARD LVCMOS25 [get_ports {hdmio_io_data[12]}]

set_property PACKAGE_PIN U17 [get_ports {hdmio_io_data[13]}]
set_property IOSTANDARD LVCMOS25 [get_ports {hdmio_io_data[13]}]

set_property PACKAGE_PIN V14 [get_ports {hdmio_io_data[14]}]
set_property IOSTANDARD LVCMOS25 [get_ports {hdmio_io_data[14]}]

set_property PACKAGE_PIN V13 [get_ports {hdmio_io_data[15]}]
set_property IOSTANDARD LVCMOS25 [get_ports {hdmio_io_data[15]}]

set_property PACKAGE_PIN U15 [get_ports hdmio_io_spdif]
set_property IOSTANDARD LVCMOS25 [get_ports hdmio_io_spdif]


##################
# Primary Clocks #
##################

# The following constraints are already created by the "ZYNQ7 Processing System" core
#create_clock -period 12.999 -name clk_fpga_0 [get_nets -hierarchical FCLK_CLK0]
#create_clock -period  7.000 -name clk_fpga_1 [get_nets -hierarchical FCLK_CLK1]
#create_clock -period 10.000 -name clk_fpga_2 [get_nets -hierarchical FCLK_CLK2]

####################
# Generated Clocks #
####################

#This is no longer necessary since there is a separate constraints file for the out of context run
# Rename auto-generated clocks from MMCM
#create_generated_clock -name hdmio_clk [get_pins wrapper/design_1_i/clk_wiz_0/inst/mmcm_adv_inst/CLKOUT0]

#create_clock -name cam_clk_Left -period 41.6667 [get_ports pclk_Left];
#create_clock -name cam_clk_Right -period 41.6667 [get_ports pclk_Right];

################
# Clock Groups #
################

#set_clock_groups -asynchronous -group [get_clocks clk_fpga_0] -group [get_clocks clk_fpga_1] -group [get_clocks clk_50M_clk_wiz_0]
set_clock_groups -asynchronous -group [get_clocks clk_fpga_0]



